
                                                 (*:  --Ŀ
                  [http://www.royale.linux-fan.com]ͻ 
                  ĿĿĿĿĿ  Ŀ  |
                .                Ŀ          
                :                   Ĵ  :
                    ٳ   Ŀ ٳ    Ŀ      .
                |           
                 [1999][royale@ifrance.com]ͼ
                --  :*)

Unit SSound;

Interface
procedure init_sound;
procedure close_sound;
procedure dmastop;
procedure playloop(sound:pointer; size,freq:word);
{procedure Playback(sound : Pointer; size : word; frequency : word);}
var sloaded:boolean;

Implementation
uses dos;
const dma_size=1000;
var      DSP_RESET : word;
     DSP_READ_DATA : word;
    DSP_WRITE_DATA : word;
  DSP_WRITE_STATUS : word;
    DSP_DATA_AVAIL : word;
    old_irq:pointer;
    irqmsk:byte;

    blaster:record port:word; dma,irq:byte; end;

procedure delay(micro:word); assembler;
asm
  mov dx,micro
  xor cx,cx
  mov ah,86h
  int 15h
end;

procedure WriteDSP(value : byte);
begin
  while Port[DSP_WRITE_STATUS] And $80 <> 0 do;
  Port[DSP_WRITE_DATA] := value;
end;

procedure DMAContinue;
begin
  if sloaded then WriteDSP($D4);
end;

procedure DMAStop;
begin
  if sloaded then WriteDSP($D0);
end;

procedure Playback(sound : Pointer; size : word; frequency : word);
var  page, offset : word;
     time_constant : word;
begin

  Port[DSP_RESET] := 1;
  Port[DSP_RESET] := 0; (* reinit for security ... *)

  size := size - 1;

  { Set the playback frequency }
  time_constant := 256 - 1000000 div frequency;
  WriteDSP($40);
  WriteDSP(time_constant);

  { Set up the DMA chip }
  offset := Seg(sound^) Shl 4 + Ofs(sound^);
  page := (Seg(sound^) + Ofs(sound^) shr 4) shr 12;
  Port[$0A] := blaster.dma+4;
  Port[$0C] := 0;
  Port[$0B] := $48+blaster.dma;
  Port[$02] := Lo(offset);
  Port[$02] := Hi(offset);
  Port[$03] := Lo(size);
  Port[$03] := Hi(size);
  Port[$83] := page;
  Port[$0A] := blaster.dma;

  { Set the playback type (8-bit) }
  WriteDSP($14);
  WriteDSP(Lo(size));
  WriteDSP(Hi(size));
end;

var cur_seg,cur_ofs,cur_pos,cur_freq,cur_size:word;
procedure playloop(sound:pointer; size,freq:word);
begin
  if not sloaded then exit;
  cur_seg:=seg(sound^);
  cur_ofs:=ofs(sound^);
  cur_freq:=freq;
  cur_size:=size;
  cur_pos:=cur_ofs;
  if cur_pos+dma_size>cur_size
  then begin
    playback(ptr(cur_seg,cur_pos),cur_size-cur_pos,cur_freq);
    cur_pos:=0;
  end else begin
    playback(ptr(cur_seg,cur_pos),dma_size,cur_freq);
    inc(cur_pos,dma_size);
  end;
end;

procedure new_irq; interrupt;
begin
  Port[$20] := $20;
  if cur_pos+dma_size>=cur_size
  then begin
    playback(ptr(cur_seg,cur_pos),cur_size-cur_pos,cur_freq);
    cur_pos:=cur_ofs;
  end else begin
    playback(ptr(cur_seg,cur_pos),dma_size,cur_freq);
    inc(cur_pos,dma_size);
  end;
end;

procedure init_sound;
var env_str:string;
    b:byte;
begin
  sloaded:=false;
  Blaster.port:=0;
  Blaster.dma:=0;
  Blaster.irq:=0;
  env_str:=GetEnv('BLASTER');
  If env_str='' then exit;
  b:=1;
  Repeat
    Case env_str[b] of
      'A' : Repeat
              Inc(b);
              Blaster.Port:=Blaster.Port*16+Ord(env_str[b])-48;
            Until env_str[b+1]=' ';
      'D' : Begin
              Blaster.DMA:=Ord(env_str[b+1])-48;
              Inc(b,2);
            End;
      'I' : Repeat
              Inc(b);
              Blaster.IRQ:=Blaster.IRQ*16+Ord(env_str[b])-48;
            Until env_str[b+1]=' ';
        End;
    Inc(b);
  Until b>Length(env_str);

  { Calculate the port addresses }
  DSP_RESET := blaster.port + $6;
  DSP_READ_DATA := blaster.port + $A;
  DSP_WRITE_DATA := blaster.port + $C;
  DSP_WRITE_STATUS := blaster.port + $C;
  DSP_DATA_AVAIL := blaster.port+ $E;

  { Reset the DSP, and give some nice long delays just to be safe }
  Port[DSP_RESET] := 1;
  delay(10000);
  Port[DSP_RESET] := 0;
  delay(10000);
  if (Port[DSP_DATA_AVAIL] And $80 = $80) And
     (Port[DSP_READ_DATA] = $AA) then begin
    getintvec($8+blaster.irq,old_irq);          { sauvegarder ancienne interruption   }
    setintvec($8+blaster.irq,@new_irq);   { positionner sur sa propre routine  }
    irqmsk := 1 shl blaster.irq;               { masquer interruption     }
    Port[$20] := $20;
    port[$21] := port[$21] and not irqmsk;
{ SpeakerOn connects the DAC to the speaker }
    WriteDSP($D1);
    sloaded:=true;
  end;
end;

procedure close_sound;
begin
  dmastop;
  setintvec($8+blaster.irq,old_irq);         { Rtablir l'ancienne interruption}
  port[$21] := Port[$21] or irqmsk;     { et ramne la masque }
  Port[$20] := $20;
end;

end.
